//--------------------------------------------------------------------//
//   vl^E (ver 2.2)					      //
//--------------------------------------------------------------------//
// NXꗗ
//  class planetarium2        C
//  class ViewPanel           ʕ
//  class DatePanel           t̓pl
//  class ControlPanel        Rg[pl
//  class StarsData           PE_
//  class PlanetsData         fEq
//  class Star                PE_NX
//  class Planet              fEqNX
//  class FileFormatException t@CO
//  class StarGraphic         \֌W
//--------------------------------------------------------------------//

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.lang.*;
import java.io.*;
import java.net.URL;
import java.util.*;

//--------------------------------------------------------------------//
// C
public class planetarium2 extends Applet{
  StarsData st;
  PlanetsData pl;
  ViewPanel view;
  DatePanel date;
  ControlPanel cont;
  String message=null;
  double jd;                                   // EX
  double lx=135.0,ly=35.0;                     // oxEܓx
  int direc=0,ddir=45;                         // Eω

//--------------------------------------------------------------------//
  public void init(){
    getData();
    jd=DatePanel.JulianDay();
    jd+=lx/360.0;

    setLayout(new BorderLayout());
    view=new ViewPanel(st,pl,jd,direc,ddir,ly,message);
    date=new DatePanel(view,jd,ly);
    cont=new ControlPanel(view);
    add("North",date);
    add("Center",view);
    add("South",cont);
  }

//--------------------------------------------------------------------//
  public void destroy(){
    remove(view);
    remove(date);
    remove(cont);
  }

//--------------------------------------------------------------------//
  public void getData(){
    String planetname,starsname,constname,s;
    InputStream is1=null,is2=null,is3=null;

    planetname=getParameter("planet");
    if(planetname==null) planetname="planet2.dat";
    starsname=getParameter("stars");
    if(starsname==null) starsname="stars2.dat";
    constname=getParameter("constellation");
    if(constname==null) constname="constellation2.dat";
    s=getParameter("longitude");
    if(s!=null) lx=Double.valueOf(s).doubleValue();
    s=getParameter("latitude");
    if(s!=null) ly=Double.valueOf(s).doubleValue();
    s=getParameter("direction");
    if(s!=null) direc=Integer.parseInt(s);
    s=getParameter("dtheta");
    if(s!=null) ddir=Integer.parseInt(s);

    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
      is1=new URL(getDocumentBase(),starsname).openStream();
      is2=new URL(getDocumentBase(),constname).openStream();
      st=new StarsData(is1,is2);
      is3=new URL(getDocumentBase(),planetname).openStream();
      pl=new PlanetsData(is3);
    }
    catch(Exception e){
      st=null;
      pl=null;
      message=e.toString();
    }
    try{
      if(is1!=null) is1.close();
      if(is2!=null) is2.close();
      if(is3!=null) is3.close();
    }
    catch(Exception e) {
    }
  }
}

//--------------------------------------------------------------------//
// ʕ
class ViewPanel extends Panel
  implements MouseListener,MouseMotionListener,KeyListener{
    StarsData st;
    PlanetsData pl;
    int prex,prey;
    double jd;                           // EX
    int direc,ddir;                      // Eω
    int str;                             // ̃|C^
    int fx,fy;                           // ʃTCY
    Color bgColor,textColor;             // wiFEF
    double ly;                           // ܓx
    int swview=1;                        // _
    String message=null;
    private Image bgImage;               // _uobt@OpC[W
    private Graphics bg;
    boolean painted=true,textsw=false;

//--------------------------------------------------------------------//
  public ViewPanel(StarsData st,PlanetsData pl,double jd,int direc,int ddir
      	      	  ,double ly,String message){
    this.st=st;
    this.pl=pl;
    this.jd=jd;
    this.direc=direc;
    this.ddir=ddir;
    this.ly=Math.PI*ly/180.0;
    this.message=message;
    bgColor=Color.black;
    textColor=Color.white;
    setBackground(bgColor);
    addMouseListener(this);
    addMouseMotionListener(this);
    addKeyListener(this);
  }

//--------------------------------------------------------------------//
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mousePressed(MouseEvent e){
    prex=e.getX();
    prey=e.getY();
    e.consume();
    str=st.getStar(prex,prey);
    if(str>=0){
      textsw=true;
      repaint();
    }
    else{
      str=pl.getPlanet(prex,prey);
      if(str>=0){
      	str+=st.nofp;
      	textsw=true;
      	repaint();
      }
    }
  }

//--------------------------------------------------------------------//
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mouseDragged(MouseEvent e){
    double coef;
    int x=e.getX();
    int y=e.getY();

    if(swview==1){
      coef=-180.0/(double)(2*fy);
    }
    else{
      coef=180.0/(double)(fy-20);
      if(y>fy/2) coef=-coef;
    }

    direc+=(int)(coef*(x-prex));
    if(direc<-180) direc+=360;
    else if(direc>180) direc-=360;
    if (painted) {
      painted=false;
      repaint();
    }
    prex=x;
    prey=y;
    e.consume();
  }

//--------------------------------------------------------------------//
  public void mouseMoved(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void keyPressed(KeyEvent e){
  }

//--------------------------------------------------------------------//
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------------------//
  public void keyTyped(KeyEvent e){
    char keyin;

    keyin=(char)e.getKeyChar();
    switch(keyin){
      case '4':
      	turnLeft();
      	break;
      case '5':
      	setView(3-swview);
      	break;
      case '6':
      	turnRight();
      	break;
      case 'c':
      	setView(3-swview);
      	break;
    }
  }

//--------------------------------------------------------------------//
  public void setDate(double ly,double jd){
// tݒ
    this.ly=Math.PI*ly/180.0;
    this.jd=jd;
    repaint();
  }

//--------------------------------------------------------------------//
  public void turnLeft(){
// ։]
    direc-=ddir;
    if(direc<-180) direc+=360;
    repaint();
  }

//--------------------------------------------------------------------//
  public void turnRight(){
// E։]
    direc+=ddir;
    if(direc>180) direc-=360;
    repaint();
  }

//--------------------------------------------------------------------//
  public void setView(int swview){
// _ݒ
    this.swview=swview;
    repaint();
  }

//--------------------------------------------------------------------//
  public void update(Graphics g){
    if(st!=null && pl!=null){
      paintScreen(g);
    }
    else if(message!=null){
      g.setColor(textColor);
      g.drawString("Error in data:",3,20);
      g.drawString(message,10,40);
    }
  }

//--------------------------------------------------------------------//
  public void paint(Graphics g){
    if(st!=null && pl!=null){
      fx=Math.max(300,getSize().width);
      fy=Math.max(150,getSize().height);
      bgImage=createImage(fx,fy);
      bg=bgImage.getGraphics();
      paintScreen(g);
    }
    else if(message!=null){
      g.setColor(textColor);
      g.drawString("Error in data:",3,20);
      g.drawString(message,10,40);
    }
  }

//--------------------------------------------------------------------//
  void paintScreen(Graphics g){
// ʕ`
    Font font;

    if(textsw){
      font=new Font("Monospaced",Font.PLAIN,12);
      bg.setFont(font);
      if(str<st.nofp){
      	st.starText(bg,str,prex,prey,fx,fy,bgColor,textColor);
      }
      else{
      	pl.planetText(bg,str-st.nofp,prex,prey,fx,fy,bgColor,textColor);
      }
      textsw=false;
    }
    else{
      font=new Font("Monospaced",Font.PLAIN,14);
      bg.setFont(font);
      bg.setColor(bgColor);
      bg.fillRect(0,0,fx,fy);
      pl.planetCoordinate(jd);
      pl.gpPlanets(swview,jd,direc,fx,fy,ly);
      if(swview==1){
      	StarGraphic.drawFrame1(bg,direc,fx,fy,textColor,pl.sunheight);
      }
      else{
      	StarGraphic.drawFrame2(bg,direc,fx,fy,textColor,pl.sunheight);
      }
      st.drawStars(bg,swview,jd,direc,fx,fy,ly);
      pl.drawPlanets(bg,swview,fx,fy);
    }
    g.drawImage(bgImage,0,0,this);
    painted=true;
  }
}

//--------------------------------------------------------------------//
// t̓pl
class DatePanel extends Panel implements ActionListener{
  ViewPanel view;
  Label llat=new Label("latitude:");
  Label lyear=new Label("year:");
  Label lmonth=new Label("month:");
  Label lday=new Label("day:");
  Label lhour=new Label("hour:");
  TextField latname;
  TextField yearname;
  TextField monthname;
  TextField dayname;
  TextField hourname;
  Button setDate=new Button("Set");
  double jd;                            // EX
  int year,month,day,hour,min,sec;      // NEEEEEb
  double ly;                            // ܓx

//--------------------------------------------------------------------//
  public DatePanel(ViewPanel view,double jd,double ly){
    int i;
    int date[]=new int[6];

    this.view=view;
    this.jd=jd;
    this.ly=ly;
    JulianDayToDate(jd,date);
    year=date[0];
    month=date[1];
    day=date[2];
    hour=date[3];
    min=0;
    sec=0;

    latname=new TextField(""+(int)ly,3);
    yearname=new TextField(""+year,4);
    monthname=new TextField(""+month,2);
    dayname=new TextField(""+day,2);
    hourname=new TextField(""+hour,2);
    setLayout(new FlowLayout());

    add(llat);
    add(latname);
    add(lyear);
    add(yearname);
    add(lmonth);
    add(monthname);
    add(lday);
    add(dayname);
    add(lhour);
    add(hourname);

    setDate.addActionListener(this);
    add(setDate);
  }

//--------------------------------------------------------------------//
  public void actionPerformed(ActionEvent e){
// t̐ݒ
    if(e.getSource().equals(setDate)){
      ly=Double.valueOf(latname.getText()).doubleValue();
      ly=Math.min(Math.max(ly,-90.0),90.0);
      year=Integer.parseInt(yearname.getText());
      month=Integer.parseInt(monthname.getText());
      day=Integer.parseInt(dayname.getText());
      hour=Integer.parseInt(hourname.getText());
      jd=DatetoJulianDay(year,month,day,hour,min,sec);
      view.setDate(ly,jd);
    }
  }

//--------------------------------------------------------------------//
  static double JulianDay(){
// EX
    Date date=new Date();
    long milisec=date.getTime();
    double julianday=2440587.5+milisec/8.64E7;
    return julianday;
  }

//--------------------------------------------------------------------//
  static void JulianDayToDate(double jday,int date[]){
// EX->tE
    int aa,bb,cc,ee,ff,gg,hh;
    double ii;

    aa=(int)(jday+68569.5);
    bb=(int)(aa/36524.25);
    cc=aa-(int)(36524.25*bb+0.75);
    ee=(int)((cc+1)/365.25025);
    ff=cc-(int)(365.25*ee)+31;
    gg=(int)(ff/30.59);
    hh=(int)(gg/11);
    ii=jday+0.5-(int)(jday+0.5);
    date[0]=100*(bb-49)+ee+hh;
    date[1]=gg-12*hh+2;
    date[2]=ff-(int)(30.59*gg);
    ii=24.0*ii;
    date[3]=(int)(ii);
    ii=60.0*(ii-(double)date[3]);
    date[4]=(int)(ii);
    date[5]=(int)(60.0*(ii-(double)date[4]));
  }

//--------------------------------------------------------------------//
// tE->EX
  static double DatetoJulianDay(int year,int mon,int day
      	      	      	       ,int hour,int min,int sec){
    int y2,m2,jdi;
    double jd,d2;

    d2=(double)day+hour/24.0+min/1440.0+sec/86400.0;
    m2=(mon+9)%12+1;
    y2=year-(int)(m2/11);
    jdi=(int)(365.25*y2)+(int)(y2/400)-(int)(y2/100)+(int)(30.59*m2);
    jd=(double)jdi+d2+1721088.5;
    return jd;
  }
}

//--------------------------------------------------------------------//
// Rg[pl
class ControlPanel extends Panel
  implements ActionListener,ItemListener{
    ViewPanel view;
    Choice viewmenu=new Choice();
    Button left=new Button("turn Left");
    Button right=new Button("turn Right");

//--------------------------------------------------------------------//
  public ControlPanel(ViewPanel view){
    this.view=view;
    setLayout(new FlowLayout());

    viewmenu.addItem("view1");
    viewmenu.addItem("view2");
    viewmenu.select(0);
    viewmenu.addItemListener(this);
    add(viewmenu);
    left.addActionListener(this);
    add(left);
    right.addActionListener(this);
    add(right);
  }

//--------------------------------------------------------------------//
  public void itemStateChanged(ItemEvent e){
// _ύX
    String viewString=null;
    int sw;

    if(e.getSource() instanceof Choice){
      viewString=(String)e.getItem();
      if(viewString.equals("view1")) sw=1;
      else sw=2;
      view.setView(sw);
    }
  }

//--------------------------------------------------------------------//
  public void actionPerformed(ActionEvent e){
// ̈ړ
    if(e.getSource().equals(left)){
      view.turnLeft();
    }
    else if(e.getSource().equals(right)){
      view.turnRight();
    }
  }
}

//--------------------------------------------------------------------//
// PE_
class StarsData{
  static final int NMAX=10000;        // P̍ől
  static final int NCON=100;          // ̍ől
  static final double RAD=Math.PI/180.0;

  int nofp,nofc;                      // E
  int nofs=0,nofn=0;                  // PE_
  Star star[]=new Star[NMAX];         // PE_NX
  String connom[]=new String[NCON];   // ̊w
  String consh[]=new String[NCON];    // ̗
  int gx[]=new int[NMAX];             // ʏWʒu
  int gy[]=new int[NMAX];
  int gz[]=new int[NMAX];

  StarsData(InputStream is1,InputStream is2)
    throws IOException, FileFormatException {
    readStarData(is1);
    readConstData(is2);
    constellationName();
  }

//--------------------------------------------------------------------//
  void readStarData(InputStream is)
    throws IOException, FileFormatException{
// PE_f[^ǂݍ
    int ii=0,colorR=0,colorG=0,colorB=0,typesw=0,radius1=0,radius2=0;
    Color color;
    double pmrad=RAD/6.0E4,hh,mm,ss,sx,sy;
    double mecx=0.0,mecy=0.0,pmx=0.0,pmy=0.0,vmag=0.0;
    String type=null,bayer=null,conste=null,name=null;
    double array[]=new double[9];
    boolean EndOfFile=false;

    StreamTokenizer st=new StreamTokenizer
      	      	      (new BufferedReader(new InputStreamReader(is)));
    st.eolIsSignificant(true);
    while(st.nextToken()!=StreamTokenizer.TT_EOL); // ڕǂݔ΂
    while(!EndOfFile){
      switch (st.nextToken()) {
      	default:
      	  EndOfFile=true;                              // t@C[
      	  break;
      	case StreamTokenizer.TT_EOL:
      	  break;
      	case StreamTokenizer.TT_WORD:
      	  type=st.sval;
      	  if(type.equals("Type")){
      	    while(st.nextToken()!=StreamTokenizer.TT_EOL);
      	    break;
      	  }
      	  else if(type.equals("Number")){
      	    while(st.nextToken()!=StreamTokenizer.TT_EOL);
      	    break;
      	  }
      	  else if(type.equals("opencl")) typesw=1;     // UJc
      	  else if(type.equals("globcl")) typesw=2;     // 󐯒c
      	  else if(type.equals("planeb")) typesw=3;     // f󐯉_
      	  else if(type.equals("brineb")) typesw=4;     // U_
      	  else if(type.equals("galaxy")) typesw=0;     // 
      	  else{                                        // P
      	    typesw=-1;
      	    bayer=type;
      	  }
      	  if(typesw==-1){
      	    if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	      conste=st.sval;
      	    if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	      name=st.sval;
      	    readNumbers(st,array,9);
      	    hh=array[0];
      	    mm=array[1];
      	    ss=array[2];
      	    mecx=15.0*RAD*(hh+mm/60.0+ss/3600.0);
      	    mm=array[3];
      	    ss=array[4];
      	    if(mm<0.0) mecy=RAD*(mm-ss/60.0);
      	    else       mecy=RAD*(mm+ss/60.0);
      	    pmx=pmrad*array[5];
      	    pmy=pmrad*array[6];
      	    vmag=array[7];
      	    radius1=StarGraphic.VmagToRad(vmag);
      	    radius2=radius1;
      	    hh=array[8];
      	    color=StarGraphic.ColorIndexBV(hh);
      	    nofs++;
      	  }
      	  else{
      	    if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	      bayer=st.sval;
      	    readNumbers(st,array,7);
      	    hh=array[0];
      	    mm=array[1];
      	    mecx=15.0*RAD*(hh+mm/60.0);
      	    hh=array[2];
      	    mm=array[3];
      	    if(hh<0.0) mecy=RAD*(hh-mm/60.0);
      	    else       mecy=RAD*(hh+mm/60.0);
      	    sx=array[4];
      	    sy=array[5];
      	    vmag=array[6];
      	    if(typesw==4) vmag=5.0-0.04*Math.sqrt(sx*sy);
      	    if(typesw==0 || typesw==4){
      	      radius1=Math.max((int)(0.02*sx+0.5),1);
      	      radius2=Math.max((int)(0.02*sy+0.5),1);
      	    }
      	    else{
      	      radius1=StarGraphic.VmagToRad(vmag);
      	      radius2=radius1;
      	    }
      	    color=StarGraphic.NebulaColor(typesw,vmag);
      	    if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	      conste=st.sval;
      	    if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	      name=st.sval;
      	    nofn++;
      	  }
      	  star[ii]=new Star(bayer,conste,name,color,radius1,radius2,mecx,mecy
      	      	      	   ,pmx,pmy,vmag);
      	  ii++;
      	  if(ii==NMAX) EndOfFile=true;
      }
    }
    is.close();
    if(st.ttype!=StreamTokenizer.TT_EOF)
      throw new FileFormatException(st.toString());
    nofp=ii;
  }

//--------------------------------------------------------------------//
  void readConstData(InputStream is)
    throws IOException, FileFormatException{
// f[^ǂݍ
    int ii=0;
    String nomen;
    boolean EndOfFile=false;

    StreamTokenizer st=new StreamTokenizer
      	      	      (new BufferedReader(new InputStreamReader(is)));
    st.eolIsSignificant(true);
    while(st.nextToken()!=StreamTokenizer.TT_EOL); // ڕǂݔ΂
    while(!EndOfFile){
      switch (st.nextToken()) {
      	default:
      	  EndOfFile=true;                               // t@C[
      	  break;
      	case StreamTokenizer.TT_EOL:
      	  break;
      	case StreamTokenizer.TT_WORD:
      	  nomen=st.sval;
      	  if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	    connom[ii]=st.sval;
      	  if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	    consh[ii]=st.sval;
      	  ii++;
      	  if(ii==NCON) EndOfFile=true;
      }
    }
    is.close();
    if(st.ttype!=StreamTokenizer.TT_EOF)
      throw new FileFormatException(st.toString());
    nofc=ii;
  }

//--------------------------------------------------------------------//
  void readNumbers(StreamTokenizer st,double array[],int n)
    throws IOException{
// ̐̓ǂݍ
    int i;
    for(i=0;i<n;i++){
      while(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      array[i]=st.nval;
    }
  }

//--------------------------------------------------------------------//
  void constellationName(){
// ̂̕ύX
    int i,j;

    for(i=0;i<nofp;i++){
      for(j=0;j<nofc;j++){
      	if(star[i].conste.equals(consh[j])) star[i].cname(connom[j]);
      }
    }
  }

//--------------------------------------------------------------------//
  int getStar(int x,int y){
// NbN
    int i,dist,pt=-1;

    for(i=0;i<nofp;i++){
      if(star[i].clickStar(x,y)) pt=i;
    }
    return pt;
  }

//--------------------------------------------------------------------//
  void drawStars(Graphics g,int sw,double jd,int direc,int fx,int fy
      	      	,double ly){
// \
    int i,fx2,fy2;

    fx2=fx/2;
    fy2=fy/2;
    for(i=0;i<nofp;i++){
      star[i].drawStar(g,sw,jd,direc,fx,fy,fx2,fy2,ly);
    }
  }

//--------------------------------------------------------------------//
  void starText(Graphics g,int pt,int x,int y,int fx,int fy
      	       ,Color bgColor,Color textColor){
// P\
    String text;

    if(pt!=-1){
// tHgݒ
      text=star[pt].bayer+" "+star[pt].conste;
      if(star[pt].name.equals("null")){}
      else text+=" "+star[pt].name;
      StarGraphic.paintText(g,text,x,y,fx,fy,bgColor,textColor);
    }
  }
}

//--------------------------------------------------------------------//
// fEq
class PlanetsData{
  static final int NMAX=100;       // f̍ől

  int nofp;                        // f
  Planet pl[]=new Planet[NMAX];    // fNX
  double rcoef;             // 1AŨsNZ
  double rmax=0.0;          // z̋̍ől
  double eps;               // XΊp
  double sunheight=-1.0;    // z̍
  int iearth=3;             // n̔ԍ

  PlanetsData(InputStream is)
    throws IOException, FileFormatException{
    readData(is);
    eps=23.43929*Math.PI/180.0;
  }

//--------------------------------------------------------------------//
  void readData(InputStream is)
    throws IOException, FileFormatException{
// f[^ǂݍ
    String name;
    Color plcolor;
    int ii=0,colorR=0,colorG=0,colorB=0,radius=0,pltype=0;
    boolean EofF=false;
    double sma=0.0,eccen=0.0,lofp=0.0,lofp2=0.0,lofan=0.0,lofan2=0.0
      	  ,inc=0.0,meanl=0.0,period=0.0,pinv=0.0;
    double array[]=new double[7];

    StreamTokenizer st=new StreamTokenizer
      	      	      (new BufferedReader(new InputStreamReader(is)));
    st.eolIsSignificant(true);
    while(st.nextToken()!=StreamTokenizer.TT_EOL); // ڕǂݔ΂
    while (!EofF) {
      switch (st.nextToken()) {
      	default:
      	  EofF=true;                               // t@C[
      	  break;
      	case StreamTokenizer.TT_EOL:
      	  break;
      	case StreamTokenizer.TT_WORD:
      	  if(st.sval.equals("pl")) pltype=1;
      	  else pltype=2;
      	  if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	    name=st.sval;
      	  if(name.equals("Earth")) iearth=ii;
      	  readNumbers(st,array,7);
      	  colorR=(int)array[0];
      	  colorG=(int)array[1];
      	  colorB=(int)array[2];
      	  plcolor=new Color(colorR,colorG,colorB);
      	  radius=Math.max((int)array[3],1);
      	  sma=array[4];
      	  eccen=array[5];
      	  lofp=array[6];
      	  if(pltype==2){
      	    if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    lofp2=st.nval;
      	  }
      	  else{
      	    lofp2=0.0;
      	  }
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    lofan=st.nval;
      	  if(pltype==2){
      	    if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    lofan2=st.nval;
      	  }
      	  else{
      	    lofan2=0.0;
      	  }
      	  readNumbers(st,array,3);
      	  inc=array[0];
      	  meanl=array[1];
      	  period=array[2];
      	  if(period==0.0)    pinv=0.0;
      	  else if(pltype==1) pinv=360.0/(365.25*period);
      	  else               pinv=360.0/period;
      	  if(pltype==1 && sma==0.0) pltype=0;  // z
      	  rmax=Math.max(rmax,sma*(1.0+eccen));
      	  pl[ii]=new Planet(name,plcolor,radius,sma,eccen,lofp,lofp2
      	      	      	   ,lofan,lofan2,inc,meanl,pinv,pltype);
      	  ii++;
      	  if(ii==NMAX) EofF=true;
      }
    }
    is.close();
    if(st.ttype!=StreamTokenizer.TT_EOF)
      throw new FileFormatException(st.toString());
    nofp=ii;
  }

//--------------------------------------------------------------------//
  void readNumbers(StreamTokenizer st,double array[],int n)
    throws IOException{
// ̐̓ǂݍ
    int i;
    for(i=0;i<n;i++){
      while(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      array[i]=st.nval;
    }
  }

//--------------------------------------------------------------------//
  void planetCoordinate(double jd){
// fWʒu
    int i;

    for(i=0;i<nofp;i++){
      pl[i].planetCoordinate(jd);
    }
  }

//--------------------------------------------------------------------//
  int getPlanet(int x,int y){
// NbNf
    int i,dist,pt=-1;

    for(i=0;i<nofp;i++){
      if(i!=iearth){
      	if(pl[i].clickPlanet(x,y)) pt=i;
      }
    }
    return pt;
  }

//--------------------------------------------------------------------//
  void gpPlanets(int sw,double jd,int direc,int fx,int fy,double ly){
// f\ʒu
    int i,fx2,fy2;
    double epss,epsc,sh;

    fx2=fx/2;
    fy2=fy/2;
    epss=Math.sin(eps);
    epsc=Math.cos(eps);
    for(i=0;i<nofp;i++){
      if(i!=iearth){
      	pl[i].PlanetMEC(pl[iearth].x,pl[iearth].y,pl[iearth].z,epss,epsc);
      	sh=pl[i].gpPlanet(sw,jd,direc,fx,fy,fx2,fy2,ly);
      	if(sh>=-1.0) sunheight=sh;
      }
    }
  }

//--------------------------------------------------------------------//
  void drawPlanets(Graphics g,int sw,int fx,int fy){
// f\
    int i,rr;

    for(i=0;i<nofp;i++){
      if(i!=iearth) pl[i].drawPlanet(g,sw,fx,fy);
    }
  }

//--------------------------------------------------------------------//
  void planetText(Graphics g,int pt,int x,int y,int fx,int fy
      	      	 ,Color bgColor,Color textColor){
// f\
    String text;

    if(pt!=-1){
// tHgݒ
      StarGraphic.paintText(g,pl[pt].name,x,y,fx,fy,bgColor,textColor);
    }
  }
}

//--------------------------------------------------------------------//
// PE_NX
class Star{
  String bayer;    // P̃oCG
  String conste;   // P̑鐯
  String name;     // P̖O
  Color color;     // \F
  int radius1;     // \a
  int radius2;     // \ca
  double mecx;     // ϐԌo
  double mecy;     // ϐԈ
  double pmx;      // ŗL^Ԍo
  double pmy;      // ŗL^Ԉ
  double vmag;     // 
  int gx,gy,gz;    // ʏWʒu

  Star(String bayer,String conste,String name,Color color
      ,int radius1,int radius2,double mecx,double mecy
      ,double pmx,double pmy,double vmag){
    this.bayer=bayer;
    this.conste=conste;
    this.name=name;
    this.color=color;
    this.radius1=radius1;
    this.radius2=radius2;
    this.mecx=mecx;
    this.mecy=mecy;
    this.pmx=pmx;
    this.pmy=pmy;
    this.vmag=vmag;
  }

//--------------------------------------------------------------------//
  void cname(String conste){
// ̂̕ύX
    this.conste=conste;
  }

//--------------------------------------------------------------------//
  void drawStar(Graphics g,int sw,double jd,int direc,int fx,int fy
      	       ,int fx2,int fy2,double ly){
// \
    int r1,r2;
    double gg[]=new double[3];

    if(sw==1){
      StarGraphic.Coordinate1(jd,mecx,mecy,direc,ly,gg);
      viewPoint1(fx,fy,fx2,fy2,gg[0],gg[1],gg[2]);
      r1=radius1;
      r2=radius2;
    }
    else{
      StarGraphic.Coordinate2(jd,mecx,mecy,direc,ly,gg);
      viewPoint2(fx,fy,fx2,fy2,gg[0],gg[1],gg[2]);
      r1=Math.max(radius1-1,1);
      r2=Math.max(radius2-1,1);
    }
    if(gx>=0 && gx<=fx && gy<=fy && gz>=0){
      g.setColor(color);
      g.fillOval(gx-r1,gy-r2,2*r1,2*r2);
    }
  }

//--------------------------------------------------------------------//
  void viewPoint1(int fx,int fy,int fx2,int fy2,double x,double y,double z){
// \ʒu
    gx=fx2+(int)(fy*x);
    gy=fy-(int)(fy*y);
    gz=(int)(fy*z);
  }
//--------------------------------------------------------------------//
  void viewPoint2(int fx,int fy,int fx2,int fy2,double x,double y,double z){
// \ʒu
    gx=fx2-(int)((fy2-10)*x);
    gy=fy2-(int)((fy2-10)*y);
    gz=(int)(fy2*z);
  }

//--------------------------------------------------------------------//
  boolean clickStar(int x,int y){
// fNbN̔
    int dist;

    if(gz>=0){
      dist=(gx-x)*(gx-x)+(gy-y)*(gy-y);
      if(dist<=radius1*radius2) return true;
    }
    return false;
  }
}

//--------------------------------------------------------------------//
// fEqNX
class Planet{
  String name;       // f̖O
  Color plcolor;     // \F
  int radius;        // \a
  double sma;        // Oa AU
  double eccen;      // S
  double lofp;       // ߓ_o ->rad
  double lofp2;
  double lofan;      // _o ->rad
  double lofan2;
  double inc;        // OXΊp ->rad
  double meanl;      // ωo ->rad
  double pinv;       // px /->rad/
  double x,y,z;      // fWʒuiz_j
  double mecx,mecy;  // fɐԓWʒuin_j
  int pltype;        // 0 - z, 1 - f, 2 - q
  int gx,gy,gz;      // ʏWʒu

  Planet(String name,Color plcolor,int radius,double sma,double eccen
      	,double lofp,double lofp2,double lofan,double lofan2,double inc
      	,double meanl,double pinv,int pltype){
    double rad=Math.PI/180.0;
    this.name=name;
    this.plcolor=plcolor;
    this.radius=radius;
    this.sma=sma;
    this.eccen=eccen;
    this.lofp=rad*lofp;
    this.lofp2=rad*lofp2;
    this.lofan=rad*lofan;
    this.lofan2=rad*lofan2;
    this.inc=rad*inc;
    this.meanl=rad*meanl;
    this.pinv=rad*pinv;
    this.pltype=pltype;
  }

//--------------------------------------------------------------------//
  void planetCoordinate(double jd){
// fWʒu
    double jday2,m,eeh,tanv,v,lens,x1,y1,x2,y2,y3,ss,cc,lofpp,lofann;

    jday2=jd-2451545.0;
    lofpp=lofp+lofp2*jday2;
    lofann=lofan+lofan2*jday2;
    m=meanl-lofpp+pinv*jday2;
    eeh=0.5*kepler(m,eccen);
    if(Math.cos(eeh)==0){
      v=Math.PI;
    }
    else{
      tanv=Math.sqrt((1.0+eccen)/(1.0-eccen))
      	  *Math.sin(eeh)/Math.cos(eeh);
      v=2.0*Math.atan(tanv);
    }
    lens=sma*(1.0-eccen*Math.cos(2.0*eeh));
    x1=lens*Math.cos(v+lofpp);
    y1=lens*Math.sin(v+lofpp);
    ss=Math.sin(lofann);
    cc=Math.cos(lofann);
    x2=x1*cc+y1*ss;
    y2=-x1*ss+y1*cc;
    y3=y2*Math.cos(inc);
    z=y2*Math.sin(inc);
    x=x2*cc-y3*ss;
    y=x2*ss+y3*cc;
  }

//--------------------------------------------------------------------//
  double gpPlanet(int sw,double jd,int direc,int fx,int fy,int fx2,int fy2
      	      	 ,double ly){
// f\ʒu
    double gg[]=new double[3];
    double sunheight=-1.0E8;

// ʏ\ʒu
    if(sw==1){
      StarGraphic.Coordinate1(jd,mecx,mecy,direc,ly,gg);
      viewPoint1(fx,fy,fx2,fy2,gg[0],gg[1],gg[2]);
      if(pltype==0) sunheight=gg[1];
    }
    else{
      StarGraphic.Coordinate2(jd,mecx,mecy,direc,ly,gg);
      viewPoint2(fx,fy,fx2,fy2,gg[0],gg[1],gg[2]);
      if(pltype==0) sunheight=gg[2];
    }
    return sunheight;
  }

//--------------------------------------------------------------------//
  void PlanetMEC(double x0,double y0,double z0,double epss,double epsc){
// fɐԓWʒu
    double dx,dy,dz,dd;

    if(pltype!=2){
      dx=x-x0;
      dy=(y-y0)*epsc-(z-z0)*epss;
      dz=(y-y0)*epss+(z-z0)*epsc;
    }
    else{
      dx=x;
      dy=y*epsc-z*epss;
      dz=y*epss+z*epsc;
    }
    dd=Math.sqrt(dx*dx+dy*dy+dz*dz);
    mecy=Math.asin(dz/dd);
    dd=Math.sqrt(dx*dx+dy*dy);
    mecx=Math.acos(dx/dd);
    if(dy<0.0) mecx=-mecx;
  }

//--------------------------------------------------------------------//
  void viewPoint1(int fx,int fy,int fx2,int fy2,double x,double y,double z){
// f\ʒu
    gx=fx2+(int)(fy*x);
    gy=fy-(int)(fy*y);
    gz=(int)(fy*z);
  }

//--------------------------------------------------------------------//
  void viewPoint2(int fx,int fy,int fx2,int fy2,double x,double y,double z){
// f\ʒu
    gx=fx2-(int)((fy2-10)*x);
    gy=fy2-(int)((fy2-10)*y);
    gz=(int)(fy2*z);
  }

//--------------------------------------------------------------------//
  void drawPlanet(Graphics g,int sw,int fx,int fy){
// f\
    int i,rr;

    if(gx>=0 && gx<=fx && gy<=fy && gz>=0){
      if(sw==1){
      	rr=radius;
      }
      else{
      	rr=Math.max(radius-2,1);
      }
      g.setColor(plcolor);
      g.fillOval(gx-rr,gy-rr,2*rr,2*rr);
    }
  }

//--------------------------------------------------------------------//
  boolean clickPlanet(int x,int y){
// fNbN̔
    int dist;

    dist=(gx-x)*(gx-x)+(gy-y)*(gy-y);
    if(dist<=radius*radius) return true;
    return false;
  }

//--------------------------------------------------------------------//
  double kepler(double m,double e){
// Pv[
    double ei,mi,dm,tol=1.0E-10;

    ei=m+e*Math.sin(m);
    mi=ei-e*Math.sin(ei);
    dm=Math.abs(m-mi);
    while(dm>tol){
      ei=ei+(m-mi)/(1.0-e*Math.cos(ei));
      mi=ei-e*Math.sin(ei);
      dm=Math.abs(m-mi);
    }
    return ei;
  }
}

//--------------------------------------------------------------------//
// t@CO
class FileFormatException extends Exception{
  public FileFormatException(String s) {
    super(s);
  }
}

//--------------------------------------------------------------------//
// \֌W
class StarGraphic{

//--------------------------------------------------------------------//
  static Color ColorIndexBV(double bv){
// FwB-V -> \F
    int rr,gg,bb;

    if(bv<=0.0){
      rr=255+(int)(382.5*bv);
      gg=255+(int)(127.75*bv);
      bb=255;
    }
    else if(bv<0.8){
      rr=255;
      gg=255;
      bb=255-(int)(159.375*bv);
    }
    else{
      rr=255;
      gg=340-(int)(106.25*bv);
      bb=127;
    }
    Color color=new Color(rr,gg,bb);
    return color;
  }

//--------------------------------------------------------------------//
  static Color NebulaColor(int type,double vmag){
// _̐F
    int rr,gg,bb;

    if(type==0){
      rr=255;
      gg=255;
      bb=204;
    }
    else if(type==4){
      rr=Math.min((int)(255*(1.0-0.1*vmag)),255);
      gg=0;
      bb=0;
    }
    else{
      rr=Math.min((int)(255*(1.0-0.1*vmag)),255);
      gg=rr;
      bb=rr;
    }
    Color color=new Color(rr,gg,bb);
    return color;
  }

//--------------------------------------------------------------------//
  static Color skyColor(double sunheight){
// z̍ -> V̐F
    int rr,gg,bb;

    if(sunheight<-0.2){
      rr=0;
      gg=0;
      bb=0;
    }
    else if(sunheight<0.0){
      rr=0;
      gg=0;
      bb=(int)(1275*(sunheight+0.2));
    }
    else if(sunheight<0.2){
      rr=0;
      gg=(int)(1275*(sunheight));
      bb=255;
    }
    else{
      rr=0;
      gg=255;
      bb=255;
    }
    Color color=new Color(rr,gg,bb);
    return color;
  }

//--------------------------------------------------------------------//
  static int VmagToRad(double vm){
//  -> \a
    int rad;

    rad=Math.max((int)(4.5-vm),1);
    return rad;
  }

//--------------------------------------------------------------------//
  static double longitude(double jd){
// V̐ԌoiPj
    double th=0.67239+1.00273781*(jd-2440000.5);
    th=2.0*Math.PI*(th-Math.floor(th));
    return th;
  }

//--------------------------------------------------------------------//
  static void Coordinate1(double jd,double mecx,double mecy
      	      	      	 ,int direc,double y,double gg[]){
// WϊiSj
    double xx,sy,cy,smy,cmy,cs,cc,sa,ca,angle;
    double tol=1.0E-6;

    xx=longitude(jd);
    sy=Math.sin(y);
    cy=Math.cos(y);

    smy=Math.sin(mecy);
    cmy=Math.cos(mecy);
    cs=cmy*Math.sin(mecx-xx);
    cc=cy*smy-sy*cmy*Math.cos(mecx-xx);
    sa=sy*smy+cy*cmy*Math.cos(mecx-xx);
    sa=2.0*Math.asin(sa)/Math.PI;
    ca=Math.sqrt(1.0-sa*sa);
    if(Math.abs(ca)<tol){
      angle=0.0;
    }
    else{
      angle=Math.acos(cc/Math.sqrt(cc*cc+cs*cs));
      if(cs<0.0) angle=-angle;
    }
    angle-=Math.PI*direc/180.0;
    gg[0]=2.0*Math.asin(Math.sin(angle))*ca/Math.PI;
    gg[1]=sa;
    gg[2]=Math.cos(angle);
  }

//--------------------------------------------------------------------//
  static void Coordinate2(double jd,double mecx,double mecy
      	      	      	 ,int direc,double y,double gg[]){
// Wϊij
    double xx,sy,cy,smy,cmy,cs,cc,sa,ca,angle;
    double tol=1.0E-6;

    xx=longitude(jd);
    sy=Math.sin(y);
    cy=Math.cos(y);

    smy=Math.sin(mecy);
    cmy=Math.cos(mecy);
    cs=cmy*Math.sin(mecx-xx);
    cc=cy*smy-sy*cmy*Math.cos(mecx-xx);
    sa=sy*smy+cy*cmy*Math.cos(mecx-xx);
    sa=2.0*Math.asin(sa)/Math.PI;
    ca=Math.sqrt(1.0-sa*sa);
    if(Math.abs(ca)<tol){
      angle=0.0;
    }
    else{
      angle=Math.acos(cc/Math.sqrt(cc*cc+cs*cs));
      if(cs<0.0) angle=-angle;
    }
    angle-=Math.PI*direc/180.0;
    gg[0]=(1.0-sa)*Math.sin(angle);
    gg[1]=(1.0-sa)*Math.cos(angle);
    gg[2]=sa;
  }

//--------------------------------------------------------------------//
  static void drawFrame1(Graphics g,int direc,int fx,int fy
      	      	      	,Color textColor,double sunheight){
// g\iSj
    double angle;
    int i,dx,dy,dx2,dy2;
    Color bgColor;
    String dir[]={"N","NE","E","SE","S","SW","W","NW"};

    dx=fx/2-fy;
    dy=2*fy;
    bgColor=skyColor(sunheight);
    g.setColor(bgColor);
    g.fillArc(dx,0,dy,dy,0,180);
    g.setColor(textColor);
    g.drawArc(dx,0,dy,dy,0,180);

    FontMetrics fm=g.getFontMetrics();
    for(i=0;i<dir.length;i++){
      angle=4.0*i/dir.length-direc/90.0;
      while(angle>2.0) angle-=4.0;
      while(angle<-2.0) angle+=4.0;
      dx=fx/2+(int)(fy*angle);
      if(dx>0 && dx<fx){
      	int textl=fm.stringWidth(dir[i]);
      	int texth=fm.getHeight();
      	g.setColor(bgColor);
      	g.fillRect(dx-textl/2-1,fy-texth-2,textl+2,texth+2);
      	g.setColor(textColor);
      	g.drawString(dir[i],dx-textl/2,fy-1);
      }
    }
  }

//--------------------------------------------------------------------//
  static void drawFrame2(Graphics g,int direc,int fx,int fy
      	      	      	,Color textColor,double sunheight){
// g\ij
    double angle;
    int i,dx,dy,dx2,dy2;
    Color bgColor;
    String dir[]={"N","NE","E","SE","S","SW","W","NW"};

    dx=(fx-fy)/2+10;
    dy=fy-20;
    bgColor=skyColor(sunheight);
    g.setColor(bgColor);
    g.fillOval(dx,10,dy,dy);
    g.setColor(textColor);
    g.drawOval(dx,10,dy,dy);

    FontMetrics fm=g.getFontMetrics();
    for(i=0;i<dir.length;i++){
      angle=4.0*i/dir.length-direc/90.0;
      while(angle>2.0) angle-=4.0;
      while(angle<-2.0) angle+=4.0;
      dx=fx/2-(int)((fy/2-6)*Math.sin(0.5*Math.PI*angle));
      dy=fy/2-(int)((fy/2-6)*Math.cos(0.5*Math.PI*angle));
      int textl=fm.stringWidth(dir[i]);
      int texth=fm.getHeight();
      g.setColor(bgColor);
      g.fillRect(dx-textl/2-1,dy-texth/2-1,textl+2,texth+2);
      g.setColor(textColor);
      g.drawString(dir[i],dx-textl/2,dy+texth/2-1);
    }
  }

//--------------------------------------------------------------------//
  static void paintText(Graphics g,String text,int x,int y
      	      	       ,int fx,int fy,Color bgColor,Color textColor){
// \
    int gx,gy;

// tHgݒ
    FontMetrics fm=g.getFontMetrics();
    int textl=fm.stringWidth(text);
    int texth=fm.getHeight();

// \ʒu
    if(x<fx-textl-20) gx=x+2;
    else gx=x-textl-4;
    if(y<texth) gy=y+2;
    else if(y<fy-texth-10) gy=y-texth/2-1;
    else gy=y-texth-4;

// wiE\
    g.setColor(bgColor);
    g.fillRect(gx,gy,textl+2,texth+2);
    g.setColor(textColor);
    g.drawString(text,gx+1,gy+texth+1);
  }
}
